   ecount=0;    %Evaluations count
   mx_stp=100;	%Maximal optimization steps number	
   dev=get(findobj(1,'Tag','b_crt_mncng'),'String');	%Deviation for optimization
   %dev=0.7; else; dev=log(eval(dev)); end
 
par_val=val_get(par_set,restr);  %Gets initial values for independent optimization parameters

TolX=get(findobj(1,'Tag','b_x_tol'),'String');	%Optimization parameter exit tolerance
%  TolX=0.0001;

TolFun=get(findobj(1,'Tag','b_f_tol'),'String');	%Optimization function exit tolerance
%      TolFun=0.0001;

MaxIter=get(findobj(1,'Tag','b_crt_mxstp'),'String');	%Maximal iteration steps
%MaxIter=2000;

f=m_round(tst_dev(par_val),3);  %Start deviation


   %block for initial data save

   cont=1;	%flag to continue search
sdev(1)=2*f;	%Successful steps deviation matrix
sdev(2)=f;	%Successful steps deviation matrix
ntest=ceil(length(par_val)^.5)+1;	%Maximal number of test from one point with the same deviation
delta=randn(size(par_val))*dev;	%First parameters deviation
par_val_t=par_val+delta;	%First test parameters
ctest=1;
dev0=exp(dev);	%parameter deviation change rate
dir=1;	%Directed search
dif=2;	%difference exponent between expanding and shrinking
dec1=1;	%Flag of first step decreasing
while cont>0
    d=tst_dev(par_val_t);
    if d<sdev(end)	%successful step
        ctest=1;	%Resetting test number
        sdev(end+1)=d;	%Adding new step deviation
        par_val=par_val_t;	%Accepting new parameters
        dev=dev*(dev0^(1/dif));	%Increasing parameter deviation
        dec1=0;	%Flag of first step decreasing
%         cb s_save; cb r_save	%Saving temporal optimization results
%         save OptmResult.txt sdev -ascii
%         cwd = pwd;
%         cd('C:\windows\temp');
%         eval('pack')
%         cd(cwd)
        if dir ==1	%Directed search
            delta=delta*(dev0^(1/dif));
        else	%Undirected search
            delta=randn(size(par_val))*dev;
        end
%        set(findobj(1,'Tag','b_itrs'),'String',length(sdev))	%Number of inerations
SndN(1);
    else	%unsuccessful step
        if ctest<ntest	%Testing directions
            if dir ==1&ctest==1&dec1==1	%Directed search, 2n attempt, after search range shrink
                delta=-1*delta;
            else	%Undirected search
                delta=randn(size(par_val))*dev;
            end
            ctest=ctest+1;
        else	%Decreasing step size
            ctest=1;	%Resetting test number
            dev=dev/(dev0^dif);
            dec1=1;
            if dir ==1	%Directed search
                delta=-1*delta/(dev0^dif);
            else	%Undirected search
                delta=randn(size(par_val))*dev;
            end
        end
    end
    par_val_t=par_val+delta;
    m=mean(sdev(max(1,end-2*ntest):end));
    if m==0
        d_fun=0;
    else
        d_fun=abs(std(sdev(max(1,end-2*ntest):end))/m);%Average criterion function deviation in success steps
    end
    cont=min([(mx_stp-ecount),sdev(end),(d_fun-TolFun)]);	%Decides to continue search(>0) or not(<=0)
end

output.funcCount=ecount %! Function counts
output.iterations=length(sdev)  %!Number of approximation steps;
fval=sdev(end)  %!Final deviation value;
