%hstsave - function for hystogram saving
function swtchtmhstsave(FileName,HstS,BinsX,BinsY,BinsZ)
%global HstS

%Inputs:
%FileName -	Filename template
%HstS -	Histogram data file
%BinsX -	X bins' boundaries vector.
%BinsY -	Y bins' boundaries vector.
%BinsZ -	Z bins' boundaries vector.

fh=fopen([FileName,'.txs'],'w');

fprintf(fh,'%16.14g\t', length(BinsX));fprintf(fh,'%16.14g\t',  length(BinsY));fprintf(fh,'%16.14g\n',  length(BinsZ));
fprintf(fh,'%16.14g\n', BinsX);
fprintf(fh,'%16.14g\n', BinsY);
fprintf(fh,'%16.14g\n', BinsZ);
for h=1:size(HstS.up,3)
	for i=1:size(HstS.up,1)
		fprintf(fh,'%16.14g\t', HstS.up(i,1:(end-1),h));fprintf(fh,'%16.14g\n', HstS.up(i,end,h));
	end
end
for h=1:size(HstS.down,3)
	for i=1:size(HstS.down,1)
		fprintf(fh,'%16.14g\t', HstS.down(i,1:(end-1),h));fprintf(fh,'%16.14g\n', HstS.down(i,end,h));
	end
end
fclose(fh);