%hstsave - function for hystogram saving
function hstsave(FileName,Hst,BinsX,BinsY)

%Inputs:
%FileName -	Filename template
%Hst -	Histogram data file
%BinsX -	X bins' boundaries vector.
%BinsY -	Y bins' boundaries vector.

fh=fopen([FileName,'.thh'],'w');
fx=fopen([FileName,'.thx'],'w');
fy=fopen([FileName,'.thy'],'w');
for i=1:size(Hst,1)
   fprintf(fh,'%16.14g\t', Hst(i,1:(end-1)));fprintf(fh,'%16.14g\n', Hst(i,end));
end
fprintf(fx,'%16.14g\n', BinsX);
fprintf(fy,'%16.14g\n', BinsY);
fclose(fh);fclose(fx);fclose(fy);