%loghst - assigns 1/3 of minimal nonzero value to all zero elements in histogram matrix.
%It's done in order to plot the whole matrix in logarithmic scale.
function HstL=loghst(Hst)
%Output:
%HstL -	Histogram matrix with assigned minimal values to zero elements.

%Input:
%Hst -	Histogram data matrix

HstL=Hst;
Positives=find(HstL>0);
if isempty(Positives)	%There are not positive values
	HstL(:)=1;
else
	HstL(find(HstL<=0))=min(min(HstL(Positives)))/3;
end

