function FitParameters=multifit_load(FileName)
%This function reads fit parameters from the file

%Inputs:
%FileName -	Filename template

%Outputs:
%FitParameters - parameters of the multidistributional fit

fidDF=fopen(FileName);	%Opens trace file
for i=1:4	%Reading text file header
	line{i}=fgetl(fidDF);
end

FitParameters=sscanf(line{2}(6:end),'%g')';
FitParameters(2,:)=sscanf(line{3}(20:end),'%g')';
FitParameters(3,:)=sscanf(line{4}(11:end),'%g')';

fclose(fidDF);
